=== lib/highlight/CMakeLists.txt ===
add_convenience_library (highlight
    highlight.hpp
    highlight.cpp
)
