=== debian/changelog ===
apitrace (13.0+repack-1) unstable; urgency=medium

  [ David Heidelberg ]
  * control: Bump policy to 4.6.2.

  [ Timo Aaltonen ]
  * New upstream release.
  * watch: Updated.
  * patches: Drop upstreamed or obsolete patches, refresh others.

 -- Timo Aaltonen <tjaalton@debian.org>  Mon, 10 Nov 2025 17:46:32 +0200
