=== debian/watch ===
Version: 5

Template: Github
Owner: apitrace
Project: apitrace
Dversion-Mangle: s/\+repack//
Repack-Suffix: +repack
